#ifndef GENERAL__LDAS_TYPES_H
#define GENERAL__LDAS_TYPES_H

/* System Header Files */
#if !defined( SWIGIMPORTED )
#include <float.h>
#endif /* ! defined(SWIGIMPORTED) */

#if !defined( SWIGIMPORTED )
#ifdef __cplusplus
#include <complex>
#endif /* __cplusplus */
#endif /* ! defined(SWIGIMPORTED) */

/* clang-format off */
typedef @LDAS_2_BYTE_INT@ INT_2S;
typedef unsigned @LDAS_2_BYTE_INT@ INT_2U;

typedef @LDAS_4_BYTE_INT@ INT_4S;
typedef unsigned @LDAS_4_BYTE_INT@ INT_4U;

typedef @LDAS_8_BYTE_INT@ INT_8S;
typedef unsigned @LDAS_8_BYTE_INT@ INT_8U;

typedef @LDAS_4_BYTE_REAL@ REAL_4;
#define REAL_4_DIGITS @LDAS_4_BYTE_REAL_DIGITS@

typedef @LDAS_8_BYTE_REAL@ REAL_8;
#define REAL_8_DIGITS @LDAS_8_BYTE_REAL_DIGITS@

typedef char          CHAR;
typedef unsigned char CHAR_U;

typedef @LDAS_VOIDP_INT_TYPE@ MEM_PTR;
/* clang-format on */

#if !defined( SWIGIMPORTED )
#ifdef __cplusplus
typedef std::complex< REAL_4 > COMPLEX_8;
typedef std::complex< REAL_8 > COMPLEX_16;
#else
/*------------------------------------------*/
/** \todo implement complex for C interface */
/*------------------------------------------*/
#endif /* __cplusplus */
#endif /* ! defined(SWIGIMPORTED) */

#endif /* GENERAL__LDAS_TYPES_H */
